package com.dhcc.finance.main.domain;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class CwBdVouchtempFExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public CwBdVouchtempFExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andPkVouchtempFIsNull() {
            addCriterion("PK_VOUCHTEMP_F is null");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempFIsNotNull() {
            addCriterion("PK_VOUCHTEMP_F is not null");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempFEqualTo(String value) {
            addCriterion("PK_VOUCHTEMP_F =", value, "pkVouchtempF");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempFNotEqualTo(String value) {
            addCriterion("PK_VOUCHTEMP_F <>", value, "pkVouchtempF");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempFGreaterThan(String value) {
            addCriterion("PK_VOUCHTEMP_F >", value, "pkVouchtempF");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempFGreaterThanOrEqualTo(String value) {
            addCriterion("PK_VOUCHTEMP_F >=", value, "pkVouchtempF");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempFLessThan(String value) {
            addCriterion("PK_VOUCHTEMP_F <", value, "pkVouchtempF");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempFLessThanOrEqualTo(String value) {
            addCriterion("PK_VOUCHTEMP_F <=", value, "pkVouchtempF");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempFLike(String value) {
            addCriterion("PK_VOUCHTEMP_F like", value, "pkVouchtempF");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempFNotLike(String value) {
            addCriterion("PK_VOUCHTEMP_F not like", value, "pkVouchtempF");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempFIn(List<String> values) {
            addCriterion("PK_VOUCHTEMP_F in", values, "pkVouchtempF");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempFNotIn(List<String> values) {
            addCriterion("PK_VOUCHTEMP_F not in", values, "pkVouchtempF");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempFBetween(String value1, String value2) {
            addCriterion("PK_VOUCHTEMP_F between", value1, value2, "pkVouchtempF");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempFNotBetween(String value1, String value2) {
            addCriterion("PK_VOUCHTEMP_F not between", value1, value2, "pkVouchtempF");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBIsNull() {
            addCriterion("PK_VOUCHTEMP_B is null");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBIsNotNull() {
            addCriterion("PK_VOUCHTEMP_B is not null");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBEqualTo(String value) {
            addCriterion("PK_VOUCHTEMP_B =", value, "pkVouchtempB");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBNotEqualTo(String value) {
            addCriterion("PK_VOUCHTEMP_B <>", value, "pkVouchtempB");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBGreaterThan(String value) {
            addCriterion("PK_VOUCHTEMP_B >", value, "pkVouchtempB");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBGreaterThanOrEqualTo(String value) {
            addCriterion("PK_VOUCHTEMP_B >=", value, "pkVouchtempB");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBLessThan(String value) {
            addCriterion("PK_VOUCHTEMP_B <", value, "pkVouchtempB");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBLessThanOrEqualTo(String value) {
            addCriterion("PK_VOUCHTEMP_B <=", value, "pkVouchtempB");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBLike(String value) {
            addCriterion("PK_VOUCHTEMP_B like", value, "pkVouchtempB");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBNotLike(String value) {
            addCriterion("PK_VOUCHTEMP_B not like", value, "pkVouchtempB");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBIn(List<String> values) {
            addCriterion("PK_VOUCHTEMP_B in", values, "pkVouchtempB");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBNotIn(List<String> values) {
            addCriterion("PK_VOUCHTEMP_B not in", values, "pkVouchtempB");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBBetween(String value1, String value2) {
            addCriterion("PK_VOUCHTEMP_B between", value1, value2, "pkVouchtempB");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBNotBetween(String value1, String value2) {
            addCriterion("PK_VOUCHTEMP_B not between", value1, value2, "pkVouchtempB");
            return (Criteria) this;
        }

        public Criteria andAssorderIsNull() {
            addCriterion("ASSORDER is null");
            return (Criteria) this;
        }

        public Criteria andAssorderIsNotNull() {
            addCriterion("ASSORDER is not null");
            return (Criteria) this;
        }

        public Criteria andAssorderEqualTo(Integer value) {
            addCriterion("ASSORDER =", value, "assorder");
            return (Criteria) this;
        }

        public Criteria andAssorderNotEqualTo(Integer value) {
            addCriterion("ASSORDER <>", value, "assorder");
            return (Criteria) this;
        }

        public Criteria andAssorderGreaterThan(Integer value) {
            addCriterion("ASSORDER >", value, "assorder");
            return (Criteria) this;
        }

        public Criteria andAssorderGreaterThanOrEqualTo(Integer value) {
            addCriterion("ASSORDER >=", value, "assorder");
            return (Criteria) this;
        }

        public Criteria andAssorderLessThan(Integer value) {
            addCriterion("ASSORDER <", value, "assorder");
            return (Criteria) this;
        }

        public Criteria andAssorderLessThanOrEqualTo(Integer value) {
            addCriterion("ASSORDER <=", value, "assorder");
            return (Criteria) this;
        }

        public Criteria andAssorderIn(List<Integer> values) {
            addCriterion("ASSORDER in", values, "assorder");
            return (Criteria) this;
        }

        public Criteria andAssorderNotIn(List<Integer> values) {
            addCriterion("ASSORDER not in", values, "assorder");
            return (Criteria) this;
        }

        public Criteria andAssorderBetween(Integer value1, Integer value2) {
            addCriterion("ASSORDER between", value1, value2, "assorder");
            return (Criteria) this;
        }

        public Criteria andAssorderNotBetween(Integer value1, Integer value2) {
            addCriterion("ASSORDER not between", value1, value2, "assorder");
            return (Criteria) this;
        }

        public Criteria andPkAccassIsNull() {
            addCriterion("PK_ACCASS is null");
            return (Criteria) this;
        }

        public Criteria andPkAccassIsNotNull() {
            addCriterion("PK_ACCASS is not null");
            return (Criteria) this;
        }

        public Criteria andPkAccassEqualTo(String value) {
            addCriterion("PK_ACCASS =", value, "pkAccass");
            return (Criteria) this;
        }

        public Criteria andPkAccassNotEqualTo(String value) {
            addCriterion("PK_ACCASS <>", value, "pkAccass");
            return (Criteria) this;
        }

        public Criteria andPkAccassGreaterThan(String value) {
            addCriterion("PK_ACCASS >", value, "pkAccass");
            return (Criteria) this;
        }

        public Criteria andPkAccassGreaterThanOrEqualTo(String value) {
            addCriterion("PK_ACCASS >=", value, "pkAccass");
            return (Criteria) this;
        }

        public Criteria andPkAccassLessThan(String value) {
            addCriterion("PK_ACCASS <", value, "pkAccass");
            return (Criteria) this;
        }

        public Criteria andPkAccassLessThanOrEqualTo(String value) {
            addCriterion("PK_ACCASS <=", value, "pkAccass");
            return (Criteria) this;
        }

        public Criteria andPkAccassLike(String value) {
            addCriterion("PK_ACCASS like", value, "pkAccass");
            return (Criteria) this;
        }

        public Criteria andPkAccassNotLike(String value) {
            addCriterion("PK_ACCASS not like", value, "pkAccass");
            return (Criteria) this;
        }

        public Criteria andPkAccassIn(List<String> values) {
            addCriterion("PK_ACCASS in", values, "pkAccass");
            return (Criteria) this;
        }

        public Criteria andPkAccassNotIn(List<String> values) {
            addCriterion("PK_ACCASS not in", values, "pkAccass");
            return (Criteria) this;
        }

        public Criteria andPkAccassBetween(String value1, String value2) {
            addCriterion("PK_ACCASS between", value1, value2, "pkAccass");
            return (Criteria) this;
        }

        public Criteria andPkAccassNotBetween(String value1, String value2) {
            addCriterion("PK_ACCASS not between", value1, value2, "pkAccass");
            return (Criteria) this;
        }

        public Criteria andAssvalueIsNull() {
            addCriterion("ASSVALUE is null");
            return (Criteria) this;
        }

        public Criteria andAssvalueIsNotNull() {
            addCriterion("ASSVALUE is not null");
            return (Criteria) this;
        }

        public Criteria andAssvalueEqualTo(String value) {
            addCriterion("ASSVALUE =", value, "assvalue");
            return (Criteria) this;
        }

        public Criteria andAssvalueNotEqualTo(String value) {
            addCriterion("ASSVALUE <>", value, "assvalue");
            return (Criteria) this;
        }

        public Criteria andAssvalueGreaterThan(String value) {
            addCriterion("ASSVALUE >", value, "assvalue");
            return (Criteria) this;
        }

        public Criteria andAssvalueGreaterThanOrEqualTo(String value) {
            addCriterion("ASSVALUE >=", value, "assvalue");
            return (Criteria) this;
        }

        public Criteria andAssvalueLessThan(String value) {
            addCriterion("ASSVALUE <", value, "assvalue");
            return (Criteria) this;
        }

        public Criteria andAssvalueLessThanOrEqualTo(String value) {
            addCriterion("ASSVALUE <=", value, "assvalue");
            return (Criteria) this;
        }

        public Criteria andAssvalueLike(String value) {
            addCriterion("ASSVALUE like", value, "assvalue");
            return (Criteria) this;
        }

        public Criteria andAssvalueNotLike(String value) {
            addCriterion("ASSVALUE not like", value, "assvalue");
            return (Criteria) this;
        }

        public Criteria andAssvalueIn(List<String> values) {
            addCriterion("ASSVALUE in", values, "assvalue");
            return (Criteria) this;
        }

        public Criteria andAssvalueNotIn(List<String> values) {
            addCriterion("ASSVALUE not in", values, "assvalue");
            return (Criteria) this;
        }

        public Criteria andAssvalueBetween(String value1, String value2) {
            addCriterion("ASSVALUE between", value1, value2, "assvalue");
            return (Criteria) this;
        }

        public Criteria andAssvalueNotBetween(String value1, String value2) {
            addCriterion("ASSVALUE not between", value1, value2, "assvalue");
            return (Criteria) this;
        }

        public Criteria andUseStateIsNull() {
            addCriterion("USE_STATE is null");
            return (Criteria) this;
        }

        public Criteria andUseStateIsNotNull() {
            addCriterion("USE_STATE is not null");
            return (Criteria) this;
        }

        public Criteria andUseStateEqualTo(String value) {
            addCriterion("USE_STATE =", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotEqualTo(String value) {
            addCriterion("USE_STATE <>", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateGreaterThan(String value) {
            addCriterion("USE_STATE >", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateGreaterThanOrEqualTo(String value) {
            addCriterion("USE_STATE >=", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLessThan(String value) {
            addCriterion("USE_STATE <", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLessThanOrEqualTo(String value) {
            addCriterion("USE_STATE <=", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLike(String value) {
            addCriterion("USE_STATE like", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotLike(String value) {
            addCriterion("USE_STATE not like", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateIn(List<String> values) {
            addCriterion("USE_STATE in", values, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotIn(List<String> values) {
            addCriterion("USE_STATE not in", values, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateBetween(String value1, String value2) {
            addCriterion("USE_STATE between", value1, value2, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotBetween(String value1, String value2) {
            addCriterion("USE_STATE not between", value1, value2, "useState");
            return (Criteria) this;
        }

        public Criteria andCreateUserIsNull() {
            addCriterion("CREATE_USER is null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIsNotNull() {
            addCriterion("CREATE_USER is not null");
            return (Criteria) this;
        }

        public Criteria andCreateUserEqualTo(String value) {
            addCriterion("CREATE_USER =", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotEqualTo(String value) {
            addCriterion("CREATE_USER <>", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserGreaterThan(String value) {
            addCriterion("CREATE_USER >", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserGreaterThanOrEqualTo(String value) {
            addCriterion("CREATE_USER >=", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLessThan(String value) {
            addCriterion("CREATE_USER <", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLessThanOrEqualTo(String value) {
            addCriterion("CREATE_USER <=", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLike(String value) {
            addCriterion("CREATE_USER like", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotLike(String value) {
            addCriterion("CREATE_USER not like", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserIn(List<String> values) {
            addCriterion("CREATE_USER in", values, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotIn(List<String> values) {
            addCriterion("CREATE_USER not in", values, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserBetween(String value1, String value2) {
            addCriterion("CREATE_USER between", value1, value2, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotBetween(String value1, String value2) {
            addCriterion("CREATE_USER not between", value1, value2, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("CREATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("CREATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("CREATE_TIME =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("CREATE_TIME <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("CREATE_TIME >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("CREATE_TIME <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("CREATE_TIME in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("CREATE_TIME not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIsNull() {
            addCriterion("UPDATE_USER is null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIsNotNull() {
            addCriterion("UPDATE_USER is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserEqualTo(String value) {
            addCriterion("UPDATE_USER =", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotEqualTo(String value) {
            addCriterion("UPDATE_USER <>", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserGreaterThan(String value) {
            addCriterion("UPDATE_USER >", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserGreaterThanOrEqualTo(String value) {
            addCriterion("UPDATE_USER >=", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLessThan(String value) {
            addCriterion("UPDATE_USER <", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLessThanOrEqualTo(String value) {
            addCriterion("UPDATE_USER <=", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLike(String value) {
            addCriterion("UPDATE_USER like", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotLike(String value) {
            addCriterion("UPDATE_USER not like", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIn(List<String> values) {
            addCriterion("UPDATE_USER in", values, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotIn(List<String> values) {
            addCriterion("UPDATE_USER not in", values, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserBetween(String value1, String value2) {
            addCriterion("UPDATE_USER between", value1, value2, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotBetween(String value1, String value2) {
            addCriterion("UPDATE_USER not between", value1, value2, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("UPDATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("UPDATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("UPDATE_TIME =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("UPDATE_TIME <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("UPDATE_TIME >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("UPDATE_TIME >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("UPDATE_TIME <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("UPDATE_TIME <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("UPDATE_TIME in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("UPDATE_TIME not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("UPDATE_TIME between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("UPDATE_TIME not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNull() {
            addCriterion("REMARK is null");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNotNull() {
            addCriterion("REMARK is not null");
            return (Criteria) this;
        }

        public Criteria andRemarkEqualTo(String value) {
            addCriterion("REMARK =", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotEqualTo(String value) {
            addCriterion("REMARK <>", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThan(String value) {
            addCriterion("REMARK >", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("REMARK >=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThan(String value) {
            addCriterion("REMARK <", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThanOrEqualTo(String value) {
            addCriterion("REMARK <=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLike(String value) {
            addCriterion("REMARK like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotLike(String value) {
            addCriterion("REMARK not like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkIn(List<String> values) {
            addCriterion("REMARK in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotIn(List<String> values) {
            addCriterion("REMARK not in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkBetween(String value1, String value2) {
            addCriterion("REMARK between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotBetween(String value1, String value2) {
            addCriterion("REMARK not between", value1, value2, "remark");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}